program L_tL_para 
use sep

implicit none

integer                          :: n1,n2,n3,n4,nxz
real                             :: o1,o2,o3,o4
real                             :: d1,d2,d3,d4 
real                             :: auxi 
complex                          :: cauxi 
integer                          :: esize,ixz,isr,jxz,i
integer                          :: block_size,n_block
complex, dimension(:,:)          :: green, MulGreen
complex, dimension(:)            :: aaaixz,aaajxz 
real,    dimension(:,:)          :: LtL 
integer, external                :: sreed,sseek_block,srite


call sep_init(SOURCE)

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history('n4',n4); call from_history('d4',d4); call from_history('o4',o4)
call from_history("esize",esize)

call to_history('n1',n2); call to_history('d1',d2); call to_history('o1',o2) ; call to_history('label1',"z" )
call to_history('n2',n3); call to_history('d2',d3); call to_history('o2',o3) ; call to_history('label2',"mx")
call to_history('n3',n2); call to_history('d3',d2); call to_history('o3',o2) ; call to_history('label3',"z" )
call to_history('n4',n3); call to_history('d4',d3); call to_history('o4',o3) ; call to_history('label4',"mx")
call to_history('n5',n4); call to_history('d5',d4); call to_history('o5',o4) ; call to_history('label5',"w")
call to_history('esize',4)

write(0,*)"n1,n2,n3",n1,n2,n3,n4
write(0,*)"d1,d2,d3",d1,d2,d3,n4
write(0,*)"o1,o2,o3",o1,o2,o3,n4

nxz=n3*n2
allocate(green(n1,nxz),LtL(nxz,nxz),MulGreen(nxz,nxz),aaaixz(n1),aaajxz(n1))

block_size=n1*nxz*esize
n_block=0
LtL=0.;
MulGreen=(0.,0.)

do i=1,n4
  write(0,*)"frequency",i
!  if (sseek_block("in",n_block,block_size,0) /=n_block) &
!     call seperr("Error seeking green function")
!  if (sreed("in",green,block_size) /=block_size) &
!     call seperr("Error reading green function")

   call sep_read(green)

   ! Computation of the second Sum
   do ixz=1,nxz
     aaaixz(1:n1)=conjg(green(1:n1,ixz)) 
     do jxz=ixz,nxz
       aaajxz(1:n1)=green(1:n1,jxz)
       cauxi=(0.,0.)
       do isr=1,n1
         cauxi=cauxi+aaaixz(isr)*aaajxz(isr)
       enddo
       MulGreen(jxz,ixz)=cauxi
       MulGreen(ixz,jxz)=cauxi
     enddo
   enddo
   
   ! Computation of the Hessian
   do ixz=1,nxz
     aaaixz(1:n1)=conjg(green(1:n1,ixz)) 
     do jxz=ixz,nxz
       aaajxz(1:n1)=green(1:n1,jxz)
       auxi=0.
       do isr=1,n1
         auxi=auxi+real( aaaixz(isr)*aaajxz(isr)*MulGreen(jxz,ixz) )
       enddo
       LtL(jxz,ixz)=auxi !ojo con esto
       LtL(ixz,jxz)=LtL(jxz,ixz)
     enddo
   enddo
   call sep_write(LtL)
!  write output 
!if ( srite ("out",LtL,4*nxz*nxz) /= 4*nxz*nxz) write(0,*) "Error writing Hessian"
enddo


!call sep_write(LtL)
deallocate(green,LtL,MulGreen)

end program L_tL_para
