! shot-profile migration
! uses split-step fourier downward continuation  with N reference velocities.
! written by Brad Artman, 2/2003

program Shotprofile

  use wei_SPmig
  use wei_wem
  use wei_SPig
  use wei_ssf
  use wei_sll
  use sep

  logical::verb
  integer::stat,ierr,iverb,n,i


  !----------------------------------------------------------------
#ifdef SEP_MPI
  call MPI_INIT(stat)
  call  set_no_putch()
#endif
  call sep_init(SOURCE)
  !----------------------------------------------------------------
#ifdef SEP_MPI
  call MPI_COMM_SIZE(MPI_COMM_WORLD, n,ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, i,ierr)
  if(i==0) then
     call from_param("verb",verb,.false.)
     iverb=0;!if(verb) iverb=1
     call MPI_SEP_SEND_ARGS(n,10,iverb)
  else
     call MPI_SEP_RECEIVE_ARGS()
  end if
  if (i==0) write(0,*) '        WEI*********************************************'
  if (i==0) write(0,*) '        * MPI mode'
  if (i==0) write(0,*) '        *         MACHINE LIST '
#endif

  call SPmig_init(SLin=weisll_init,&
                  WCin=weikxmigN_init,&
                  FKin=weiwem_init,&
                  FXin=weissf_init,&
                  IGin=SPig_init )
!write(0,*) 'here main'
  stat=SPmig(.true.,down%add,down%R,down%D,down%D_d, &
             SLop=weisll, &
             WCop=weikxmigN_shot, &
             FKop=weiwem_fast,&
             FXop=weissf,&
             IGop=SPigop)

#ifdef SEP_MPI
  call MPI_FINALIZE(ierr) 
#endif
  call sep_close()

  call exit(0)
end program Shotprofile


