module wei_down
  use sep
  use wei_var
  use wei_run
  use wei_down_type
  integer,private,save :: idone,iblocks,nblocks,nzb,nwb !Number of blocks for this thread
  !----------------------------------------------------------------



contains
  !----------------------------------------------------------------
  logical function down_init()
#ifdef DEBUG
    character(len=128), parameter :: unit='process_init'
    call in(unit)
#endif

    down_init=F
    !OPERATION SETUP
    call from_param('adj', down%adj, .true.)
    call from_param('add', down%add, .false.)

    !! inversion begins with adjoint, too
    if(run%operation(1:10) .eq. 'inversion.') then
       down%adj=.true. 
    end if

    call from_param("multsub",down%multsub,.false.)
    call from_param('eps',down%eps,100.)

    call from_param("passive",down%passive,.false.);
    call from_param("marine",down%marine,.true.)
    if (down%passive) down%marine=.false.
    !HANDLE CONVERTED WAVE 
    ierr=getch("S_S","d",ierr)+getch("S_G","d",ierr)
    if(2==ierr) then
       down%VS='S_S'   !!       slowness
       down%VG='S_G'   !!       slowness
       down%conv_wave=.true.
    else if( 1==ierr) then
       write(0,*) "Must provide S_S and S_G"
       return
    else
       down%VS='S'
       down%VG='S'
       down%conv_wave=.false.
    end if

!rite(0,*) 'shit4'
    !HANDLE SHARED IMAGE FILE
    if(run%share_image) then
       down%image_lock="LOCK."//trim(run%mach)
    end if

    down%wIOd=.false.  !! flag whether I/O on wavefield.
    down%wIOu=.false.  !! flag whether I/O on wavefield.
    down%dS   ='dS'    !! delta slowness
    down%D    ='D'     !! receiver data
    down%D_d  ='D_d'   !! src data
    down%U    ='U'     !! some downward continued wavefield
    down%R    ='R'     !! working image space
    down%dR   ='dR'    !! delta image
    down%W    ='W'     !! working space sized wavefield coming up
    down%W_d  ='W_d'   !! working space sized wavefield going down
!rite(0,*) 'shit5'
    call from_param('image_freqs',down%image_freqs,.false.)
    call from_param("firstz",down%firstz,1)
    if(.not.down%image_freqs) down%firstz=1

    !! get basic depth components from slowness file (S)
    call hinaxis('S',down%az,3);
    call from_param("nzs",down%nzs,down%az%n); down%nzb=0;
    call from_param("autonzs",down%autonzs,.true.)
    if(down%image_freqs) down%autonzs=.true.
    if (down%autonzs) down%nzs=down%az%n
!rite(0,*) 'shit6'
    !! get basic freq. components from data file (D)
    call hinaxis('D',down%aw,3)
    if(down%aw%n==1) call erexit("Only one frequency?? Rediculous")
    call from_param("nws",down%nws,down%aw%n/run%m_nth)
    call from_param("autonws",down%autonws,.true.)
    if(down%image_freqs) down%autonws=.true. !necessary??
    if (down%autonws) down%nws=down%aw%n/run%m_nth ;  down%nwb=0

    !! get width of source function
    if (.not.down%passive) then
       call hinaxis('D_d',down%fatx,1)
       call hinaxis('D_d',down%faty,2)
    else
       down%fatx%n=1; down%faty%n=1
    end if
!    if (mod(down%nws,run%m_nth)/=0 ) then 
!       if(run%verb)write(0,*) down%nws,"=down%nws run%m_nth=",run%m_nth
!       if(run%verb)write(0,*) "number of machines must be a factor of nws",mod(down%nws,run%m_nth)
!       return
!    end if
    if(mod(down%aw%n,down%nws)/=0 ) then 
       if(run%verb)write(0,*) down%aw%n,"=down%aw%n down%nws=",down%nws
       if(run%verb)write(0,*)  "nws must be a factor of down%aw%n",mod(down%aw%n,down%nws)
       return
    end if
!rite(0,*) 'shit7'
    !! ?should have odd number of offsets as zero is included
    call from_param('ahx_n',down%ahx%n,1)
    call from_param('ahy_n',down%ahy%n,1)
    if (mod(down%ahx%n,2)==0) down%ahx%n=down%ahx%n+1 
    if (mod(down%ahy%n,2)==0) down%ahy%n=down%ahy%n+1 
 
    !!FIGURE OUT VARIABLE SLOWNESS
    call from_param("order",down%order,"ANY")
    if(.not. wei_var_init()) then
       write(0,*) "trouble initializing variable step"
    end if
    if(down%order(1:3) == "VAR") then
    else if(down%order(1:3) == "ANY") then
       down%order="OZ";if(down%nzs > 10) down%order="OF"
    else if(down%order(1:2) == "OF" .or. down%order(1:2) == "OZ" ) then
    else 
       write(0,*) "invalid order ",trim(down%order), " must be OF,OZ,VAR, or ANY"
       return
    end if

    !! number of reference velocities
    call from_param("nref",down%nref,1)
    !! exploding reflector migration
    call from_param("exp_ref",down%exp_ref,.false.)

    !! antialias limits
    call from_param("antialias",down%antion,.false.)
    call from_param("pmax_x",down%pmax_x,1000000.)
    call from_param("pmax_y",down%pmax_y,down%pmax_x)
    call from_param("pmin_x",down%pmin_x,-down%pmax_x)
    call from_param("pmin_y",down%pmin_y,-down%pmax_y)

!    call from_param("kmax_x",down%pmax_x,down%pmax_x)
!    call from_param("kmax_y",down%pmax_y,down%pmax_y)
!    call from_param("kmin_x",down%pmin_x,down%pmin_x)
!    call from_param("kmin_y",down%pmin_y,down%pmin_y)
down%pmax_y=1000.;down%pmin_y=-1000.
    if(run%verb) call down_report()

    down_init=T
#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
  end function down_init
!----------------------------------------------------------------
subroutine down_global_var_calc(X)
type(wedata),intent(in) :: X
 integer::bogus
!! . . Define propagation wavefield on model surface
     down%amx=X%amx
     down%amy=X%amy
if(.not.down%passive) then
   if(down%marine )then
      if(X%amx%n > 1)then
         down%amx%n=max(abs(X%amx%o)                      /X%amx%d +1.5,&
                           (X%amx%o + (X%amx%n-1)*X%amx%d)/X%amx%d +1.5,&
                                       X%amx%n)
         down%amx%o=min(X%asx%o+X%amx%o, X%asx%o)
      end if
      if(X%amy%n > 1)then
         down%amy%n=max(abs(X%amy%o)                      /X%amy%d +1.5,&
                           (X%amy%o + (X%amy%n-1)*X%amy%d)/X%amy%d +1.5,&
                                       X%amy%n)
         down%amy%o=min(X%asy%o+X%amy%o, X%asy%o)
      end if
!if(run%verb)write(0,*) 'marine global_var_calc'
!if(run%verb)write(0,*) 'vars'
!if(run%verb)write(0,*) abs(X%amx%o),X%amx%d,X%amx%o,X%amx%n-1,(X%amx%n-1)*X%amx%d,down%fatx%n
!if(run%verb)write(0,*) 'equns'
!if(run%verb)write(0,*) abs(X%amx%o)/X%amx%d +1.5,(X%amx%o + (X%amx%n-1)*X%amx%d)/X%amx%d +1.5
!if(run%verb)write(0,*) 'reulst'
!if(run%verb)write(0,*) max(abs(X%amx%o)/X%amx%d +1.5,(X%amx%o + (X%amx%n-1)*X%amx%d)/X%amx%d +1.5),&
!    max(abs(X%amx%o)/X%amx%d +1.5,(X%amx%o + (X%amx%n-1)*X%amx%d)/X%amx%d +1.5)+(down%fatx%n-1)/2.
!if(run%verb)write(0,*) 'on to the origin'
!if(run%verb)write(0,*) 'eqns'
!if(run%verb)write(0,*) X%asx%o+X%amx%o,X%asx%o - (down%fatx%n-1)*down%amx%d/2.,min(X%asx%o+X%amx%o,X%asx%o - (down%fatx%n-1)*down%amx%d/2.)
!if(run%verb)write(0,*) 'result'
!if(run%verb)write(0,*) down%amx%o
   else
      if(X%amx%n > 1)then
         down%amx%o=min(X%amx%o, X%asx%o - (down%fatx%n-1)*down%amx%d/2.)
         down%amx%n=down%amx%n+(down%faty%n-1)
!if(run%verb)write(0,*) 'land global_var_calc'
!if(run%verb)write(0,*) 'down_amx_n,o',down%amx%n,down%amx%o
      end if
      if(X%amy%n > 1)then
         down%amy%o=min(X%amy%o, X%asy%o - (down%faty%n-1)*down%amy%d/2.)
         down%amy%n=down%amy%n+(down%faty%n-1)
if(run%verb)write(0,*) 'land global_var_calc',X%tag
if(run%verb)write(0,*) 'wei_down down%amy%o, %n',down%amy%o, down%amy%n
if(run%verb)write(0,*) 'wei_down X%amy%o, %n',X%amy%o, X%amy%n
      end if
   end if
end if
!! . . Set frequency values
    down%aw=X%aw;    down%bw=down%aw
   
!! . . Apply history values for shot axes
    down%asx=X%asx
    down%asy=X%asy
!! . . image values
    down%aix=X%amx ;down%aiy=X%amy 
   if((.not.down%passive) .and. (down%marine) ) then 
!! . . image space setup x
      if(X%amx%n .gt.1) then
      if(X%amx%o < 0) then
         down%aix%n=(1.5+(abs(X%amx%o)                      + (X%asx%n-1)*X%asx%d)/X%amx%d) !!no +offs
              bogus=(1.5+    (          (X%amx%n-1)*X%amx%d + (X%asx%n-1)*X%asx%d)/X%amx%d) !!- and +offs
         down%aix%n=max(down%aix%n,bogus)
         down%aix%o=X%asx%o + X%amx%o
      else
         down%aix%n=(1.5+    (X%amx%o + (X%amx%n-1)*X%amx%d + (X%asx%n-1)*X%asx%d)/X%amx%d) !!no -offs
         down%aix%o=X%asx%o
      end if
      end if

!! . . image space setup y
      if(X%amy%n .gt.1) then
      if(X%amy%o < 0) then
         down%aiy%n=(1.5+(abs(X%amy%o)                      + (X%asy%n-1)*X%asy%d)/X%amy%d) !!no +offs
              bogus=(1.5+    (          (X%amy%n-1)*X%amy%d + (X%asy%n-1)*X%asy%d)/X%amy%d) !!- and +offs
         down%aiy%n=max(down%aiy%n,bogus)
         down%aiy%o=X%asy%o + X%amy%o
      else
         down%aiy%n=(1.5+    (X%amy%o + (X%amy%n-1)*X%amy%d + (X%asy%n-1)*X%asy%d)/X%amy%d)!!no -offs
         down%aiy%o=X%asy%o
      end if
      end if

   end if

end subroutine down_global_var_calc
!----------------------------------------------------------------
  subroutine down_reset2(adj,add,mod_,dat_,dat_d_)
    logical,            intent(in) :: adj,add
    character(len=128), intent(in) :: mod_,dat_,dat_d_
!    character(len=128), intent(in),optional::dat_d
 
    down%adj  = adj
    down%add  = add
    if(run%restart) down%add=.true.
    down%mod_ = mod_
    down%dat_ = dat_
    down%dat_d_ = dat_d_

  end subroutine down_reset2
  !----------------------------------------------------------------  
  subroutine down_report()
    call weiline()
    write(run%io_unit,*)                    "        *  Down report"
    write(run%io_unit,'(a,i5)')             "         *         nzs=",down%nzs
    write(run%io_unit,'(a,i5)')             "         *        nref=",down%nref
    write(run%io_unit,*)                    "        *      marine=",down%marine
    write(run%io_unit,*)                    "        * image_freqs=",down%image_freqs
    if(down%antion) then
    write(run%io_unit,*)                    "        *  anti alias:  ON"
    write(run%io_unit,*)                    "        *      kmax_x=",down%pmax_x
    write(run%io_unit,*)                    "        *      kmin_x=",down%pmin_x
    write(run%io_unit,*)                    "        *      kmax_y=",down%pmax_y
    write(run%io_unit,*)                    "        *      kmin_y=",down%pmin_y

    else
    write(run%io_unit,*)                    "        *  anti alias:  OFF"
    end if

  end subroutine down_report

  subroutine set_blocks(n_wb,n_zb,n_blocks)
   integer,optional :: n_zb,n_wb,n_blocks
   if(present(n_zb)) nzb=n_zb
   if(present(n_wb)) nwb=n_wb
   if(present(n_blocks)) nblocks=n_blocks
  end subroutine
  !----------------------------------------------------------------
  subroutine wei_followup(izb,iwb)
    integer :: iwb,izb
    write(run%io_unit,'( "         *&
     & done ",f5.2,"%","    izb=",i4,"/",i4,"     iwb=",i4,"/",i4)') &
     real(idone)/real(nblocks)*100.,izb,nzb,iwb,nwb
     idone=idone+1
  end subroutine wei_followup
!  subroutine wei_followup(izb,iwb,k)
!    integer :: iwb,izb,k
!    write(run%io_unit,'( "         *&
!     & done ",f5.2,"%","    izb=",i4,"/",i4,"     iwb=",i4,"/",i4)') &
!     real(idone)/real(nblocks)*100.,izb,nzb,iwb,nwb/nws
!     idone=idone+k
!  end subroutine wei_followup
  !----------------------------------------------------------------
  subroutine process_radians()
    down%aw%o = 2*pi * down%aw%o
    down%aw%d = 2*pi * down%aw%d
    down%bw%o = 2*pi * down%bw%o
    down%bw%d = 2*pi * down%bw%d
    down%pmax_x = 2* pi *down%pmax_x
    down%pmax_y = 2* pi *down%pmax_y
    down%pmin_x = 2* pi *down%pmin_x
    down%pmin_y = 2* pi *down%pmin_y 
!f(run%verb)write(0,*) 'pmax_x' ,down%pmax_x
!f(run%verb)write(0,*) 'pmax_y' ,down%pmax_y
!f(run%verb)write(0,*) 'pmin_y' ,down%pmin_y
!f(run%verb)write(0,*) 'pmin_x' ,down%pmin_x
  end subroutine process_radians


  !----------------------------------------------------------------
end module wei_down



