module wei_down_type
  use wei_util
  use wei_type

  type weidown
     character(len=128) ::  VS,VG, D,D_d,R,U, W,W_d !! file tags
     character(len=128) :: dS,dR,mod_,dat_,dat_d_
     character(len=128) :: order
     character(len=128) :: image_lock
     integer            :: image_lock_fd
     logical            :: adj, add
     logical            :: marine !! marine (constant offset from shot)
     integer            :: opsign
     logical            :: image_freqs  !! write image as function of freqs
     !! simultate conjg(phase) to avoid 'if'
     !! opsign=goB2T (e.g.  modeling)
     !! opsign=goT2B (e.g. migration)
     integer            :: firstz  !! first depth index to image
     integer            :: nzs     !! number of depth     slices in a block
     integer            :: shotnum !! shotcounter
     integer            :: nws     !! number of frequency slices in a block
     integer            :: nzb     !! number of depth     blocks
     integer            :: nwb     !! local  number of frequency blocks
     integer            :: nwp     !! global  number of frequency block
     integer            :: nref    !! number of  reference velocities
     logical            :: conv_wave!! whether or not we are doing converted wave velocity
     logical            :: multsub  !!multiple subtraction at imaging condition
     real               :: eps      !!for multiple subtraction
     logical            :: exp_ref  !! exploding reflector migration
     logical            :: passive  !! passive seismic ShotProfile migration
     logical            :: autonws  !! set nws=aw%n/m_nth
     logical            :: autonzs   !! set nzs=az%n
     logical            :: wIOu !! writing wavefields?
     logical            :: wIOd !! writing wavefields?
     integer,pointer    :: iw_thread(:) !! which mpi thread  each
     integer,pointer    :: iw_first(:)  !! First actual iw in each block
     integer            :: nw_local     !! Number of local frequencies
     integer,pointer    :: iz_write(:)  !! First z block to write
     logical            :: antion !! apply antialiasing?
     real               :: pmin_y,pmax_y !! antialias limits
     real               :: pmin_x,pmax_x !! antialias limits
     type(axis)         :: fatx,faty   !!spatial thickness of source function (same as amx)
     type(axis)         :: amx,amy !! receiver axes
     type(axis)         :: asx,asy !! shot axes
     type(axis)         :: ahx,ahy !! offsets computed in shotprofile imaging condition
     type(axis)         :: aix,aiy !! total image from all shots
     type(axis)         :: az,bz   !! depth
     type(axis)         :: aw,bw   !! frequency
     type(weslow)       :: S       !! slowness
     complex, pointer   :: block(:,:,:)
     real, pointer      :: max_slow(:) 
  end type weidown
  !! !!!!!!!!!!!!!!!!!!!!!!!!!!!!
  type(weidown), public :: down
  !! !!!!!!!!!!!!!!!!!!!!!!!!!!!!
end module wei_down_type
