module wei_var_type
  !---------------
  type  z_step
    real, pointer ::  dz(:)
    real, pointer ::  zloc(:)
    integer,pointer :: status(:)
    integer, pointer :: iloc(:,:)
    real, pointer :: frac(:,:)
  end type

  !----------------------------------------------------------------
  !
  !
  ! A type to handle variable sampling
  !
  !
  !
  type weivar
     character(len=128) :: operator
     character(len=128) :: operation,file_out
     type(z_step),pointer:: z_samp(:)   ! Sampling of local frequencies
     integer            :: distribute_pattern ! 0-reg,1-vel,2-vel+freq,
                                             ! 3-vel+freq+attenuation

     real,pointer       :: dzb(:) !z sampling for the current block
     integer,pointer    :: ihxb_beg(:) !beg loop for cur z block for hx axis
     integer,pointer    :: ihyb_beg(:) !beg loop for cur z block for hy axis
     integer,pointer    :: ihxb_end(:) !end loop for cur z block for hx axis
     integer,pointer    :: ihyb_end(:) !end loop for cur z block for hy axis
     complex,pointer    :: v_i_buf(:,:,:,:,:) !variable image buffer
     logical, pointer   :: filled(:) !whether or not output iz has been finished
     integer, pointer   :: disk_buf(:)!iz disk buffer element used
     integer, pointer   :: mem_buf(:)!iz memory buffer element used
     integer, pointer   :: write_freq(:) ! what block to start writing on
     integer            :: nmem_buf,ndisk_buf
     logical            :: use_disk_buf ! using disk buf
  end type weivar
  type(weivar) :: var
end module
