module wei_xmap
  !! X-domain mapping

  use wei_run
  use wei_down_type
  use wei_type
  !---------------
  implicit none

  !! !!!!!!!!!!!!!!!!!!!!!!!!!!!!
  type(wexmap), public :: xmap
  !! !!!!!!!!!!!!!!!!!!!!!!!!!!!!

contains
  !----------------------------------------------------------------
  subroutine weixmap_init()
    integer :: imx,imy
    integer :: er
#ifdef DEBUG
    character(len=128), parameter :: unit='weixmap_init'
    if(run%debug) call in(unit)
#endif

    !! mx
    allocate(xmap%mx(down%amx%n),stat=er)
    if(er/=0) call seperr('cant allocate mx')
    !! my
    allocate(xmap%my(down%amy%n),stat=er)
    if(er/=0) call seperr('cant allocate my')

    call wei_xmap()
#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
  end subroutine weixmap_init
  !----------------------------------------------------------------
  !----------------------------------------------------------------
  subroutine wei_xmap()
    integer :: imx,imy
    integer :: er

#ifdef DEBUG
    character(len=128), parameter :: unit='wei_xmap'
    if(run%debug) call in(unit)
#endif

    !! mx
    do imx=1,down%amx%n
       xmap%mx(imx) = down%amx%o + (imx-1)* down%amx%d
    end do

    !! my !did the same thing as above
    do imy=1,down%amy%n
       xmap%my(imy) = down%amy%o + (imy-1)* down%amy%d
    end do

#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
  end subroutine wei_xmap
  !----------------------------------------------------------------
end module wei_xmap
